//board/BoardDB.java
/** ̺ BOARD
 REGID                                                 NOT NULL NUMBER(13)
 REGNAME                                               NOT NULL VARCHAR2(40)
 SUBJECT                                               NOT NULL VARCHAR2(100)
 CONTENT                                               NOT NULL VARCHAR2(4000)
 */
package board;


import java.sql.*;
import java.util.Vector;

public class BoardDB
{
	private Connection con;
	private Statement stmt;

	public BoardDB()
	{
		try{
			Class.forName("oracle.jdbc.driver.OracleDriver");
		}catch(ClassNotFoundException cnf) {
			System.out.println("DriverLoading Error"+ cnf);
		}
	}

	private void connect()
	{
		String url = "jdbc:oracle:thin:@127.0.0.1:1521:ORCL";
		String id = "scott";
		String pass = "tiger";

		try{
			con = DriverManager.getConnection(url, id, pass);
			stmt = con.createStatement();
		}catch(SQLException se) {
			System.out.println("connect() error" + se);
		}
	}

	private void disconnection()
	{
		try{
			stmt.close();
			con.close();
		}catch(SQLException se) {
			System.out.println("disconnection() error" + se);
		}
	}

	public void write(Board board) throws SQLException 
	{
		StringBuffer query = new StringBuffer();
		query.append("insert into board values((select  NVL(max(regid),0)+1 from board),");
		query.append(word(board.getName())).append(",");		
		query.append(word(board.getTitle())).append(",");		
		query.append(word(board.getContent())).append(")");

		connect();
		System.out.println(query.toString());
		stmt.executeUpdate(query.toString());
		disconnection();
	}
	
	public void update(Board board) throws SQLException 
	{
		StringBuffer query = new StringBuffer();
		query.append("update board set regname=");
		query.append(word(board.getName())).append(",");
		query.append("subject=");
		query.append(word(board.getTitle())).append(",");
		query.append("content=");
		query.append(word(board.getContent())).append(" where regid=");
		query.append(word(board.getNo()));
		
		connect();
		System.out.println(query.toString());
		stmt.executeUpdate(query.toString());
		disconnection();
	}
	
	public void delete(String no) throws SQLException
	{
		String query = "delete from board where regid="+ word(no);
		
		connect();
		System.out.println(query.toString());
		stmt.executeUpdate(query.toString());
		disconnection();		
	}
	
	public Board read(String no) throws SQLException
	{
		String query = "select * from board where regid="+ word(no);
		ResultSet result = null;
		Board board = null;

		connect();
		System.out.println(query.toString());
		result = stmt.executeQuery(query);
		if(result.next())
		{
		  
		  board = new Board(result.getString("regid"),result.getString("regname"),result.getString("subject"),
						result.getString("content"));		  
		}
		disconnection();
		return board;
	}

	public Vector getList() throws SQLException
	{
		Vector list = new Vector(10,5);
		String query = "select regid, regname, subject from board";

		connect();
		ResultSet result = stmt.executeQuery(query);
		while(result.next())
		{
			Board board = new Board(result.getString("regid"),result.getString("regname"),result.getString("subject"),null);
			list.addElement(board);
		}
		disconnection();
		return list;
	}

	private String word(String s)
	{
		return "'" + s + "'";
	}
}
